#!/usr/bin/env python3

import os, fnmatch
import argparse
import gettext

all_count = 0
newfile = "new_empty.txt"

HEADER = '\033[94m'
GREEN = '\033[92m'
WARNING = '\033[93m'
RED = '\033[91m'
CYAN = '\033[36m'
ENDC = '\033[0m'
BOLD = '\033[1m'
UNDERLINE = '\033[4m'
#BK_LIGHT_BLACK = '\033[100m'

def find(pattern, path):
    result = []
    for root, dirs, files in os.walk(path):
        for name in files:
            if fnmatch.fnmatch(name, pattern):
                result.append(os.path.join(root, name))
    return result

def show_diff_line(file_name, line_number, line):
    global old_word
    global new_word
    global _color
    global _back_color

    if _back_color:
        BK_LIGHT_BLACK = '\033[100m'
    else:
        BK_LIGHT_BLACK = ''

    if _color or _back_color:
        print(CYAN + _("@@ file: {0}, line: {1} @@").format(file_name, line_number)+ ENDC)
        print(RED + _("--- ") + ENDC + line.replace(
            old_word, BK_LIGHT_BLACK + RED + old_word + ENDC), end="")
        print(GREEN + _("+++ ") + ENDC + line.replace(
            old_word, BK_LIGHT_BLACK + GREEN + new_word + ENDC))

    else:
        print(_("@@ file: {0}, line: {1} @@").format(file_name, line_number))
        print(_("--- ")+ line, end="")
        print(_("+++ ")+ line.replace(old_word, new_word))

def show_diff_line_no_change(file_name, line_number, line):
    global old_word
    global _color
    global _back_color

    if _back_color:
        BK_LIGHT_BLACK = '\033[100m'
    else:
        BK_LIGHT_BLACK = ''

    if _color or _back_color:
        print(CYAN + _("@@ file: {0}, line: {1} @@").format(file_name, line_number)+ ENDC)
        print(HEADER + _("??? ") + ENDC + line.replace(
            old_word, BK_LIGHT_BLACK + HEADER + old_word + ENDC))

    else:
        print(_("@@ file: {0}, line: {1} @@").format(file_name, line_number))
        print(_("??? ") + line, end="")

def auto_and_show(file_name):
    count = 0
    line_number = 0
    global all_count
    global old_word
    global new_word
    file = open(file_name, "r")
    file2 = open(newfile, "w")

    for line in file:
        line_number += 1
        line_count = line.count(old_word)

        if (line_count > 0):
            show_diff_line(file_name, line_number, line)
            count += line_count
            file2.write(line.replace(old_word, new_word))
        else:
            file2.write(line)
    file.close()
    file2.close()
    if (count >= 1) :
        all_count += count
        os.replace(newfile, file_name)

def auto_and_not_show(file_name):
    count = 0
    global all_count
    global old_word
    global new_word
    file = open(file_name, "r")
    file2 = open(newfile, "w")

    for line in file:
        line_count = line.count(old_word)

        if (line_count > 0):
            count += line_count
            file2.write(line.replace(old_word, new_word))
        else:
            file2.write(line)
    file.close()
    file2.close()
    if (count >= 1) :
        all_count += count
        os.replace(newfile, file_name)

def not_auto_and_show(file_name):
    count = 0
    line_number = 0
    global all_count
    global old_word
    global new_word
    file = open(file_name, "r")
    file2 = open(newfile, "w")

    for line in file:
        line_number += 1
        line_count = line.count(old_word)

        if (line_count > 0):
            show_diff_line(file_name, line_number, line)
            if (input(_("do you want to replae it : (y/n) ")) == "y"):
                count += line_count
                file2.write(line.replace(old_word, new_word))
            else:
                file2.write(line)
        else:
            file2.write(line)
    file.close()
    file2.close()
    if (count >= 1) :
        all_count += count
        os.replace(newfile, file_name)

def not_auto_and_not_show(file_name):
    count = 0
    line_number = 0
    global all_count
    global old_word
    global new_word
    file = open(file_name, "r")
    file2 = open(newfile, "w")

    for line in file:
        line_number += 1
        line_count = line.count(old_word)

        if (line_count > 0):
            print(_("file: {0}, line: {1}, match word: {2}. replace or show : (y/s/n) ").format(file_name, line_number, line_count), end="")
            e = input("")
            if (e == "y"):
                count += line_count
                file2.write(line.replace(old_word, new_word))
            elif (e == "s"):
                show_diff_line(file_name, line, line_number)
                if input(_("do you want to replae it : (y/n) ")) == "y":
                    count += line_count
                    file2.write(line.replace(old_word, new_word))
                else:
                    file2.write(line)
            else:
                file2.write(line)
        else:
            file2.write(line)
    file.close()
    file2.close()
    if (count >= 1) :
        all_count += count
        os.replace(newfile, file_name)

def auto_and_show_no_change(file_name):
    count = 0
    line_number = 0
    global all_count
    global old_word
    file = open(file_name, "r")

    for line in file:
        line_number += 1
        line_count = line.count(old_word)

        if (line_count > 0):
            show_diff_line_no_change(file_name, line_number, line)
            count += line_count
    file.close()
    all_count += count

def not_auto_and_show_no_change(file_name):
    count = 0
    line_number = 0
    global all_count
    global old_word
    file = open(file_name, "r")

    for line in file:
        line_number += 1
        line_count = line.count(old_word)

        if (line_count > 0):
            show_diff_line_no_change(file_name, line_number, line)
            input(_("next line: "))
            count += line_count
    file.close()
    all_count += count

def main():
    lang = os.getenv("LANGUAGE", default="en")
    lang_translations = gettext.translation('base', localedir='locales', languages=[lang])
    lang_translations.install()
    _ = lang_translations.gettext

    parser = argparse.ArgumentParser(
        description=_("replace old-text whit new-text"),
        epilog=_("./replace.py -o old-text -n new-text -f *.txt -r -a"))

    parser.add_argument('-o', '--old-word', action="store", help=_("the old text you want be replace whit the new one"), default="")
    parser.add_argument('-n', '--new-word', action="store", help=_("the new text you want convert old text to this"), default="")
    parser.add_argument('-f', '--file', action="store", help=_("file or files you want to search and replace for the words"), default="*.txt")
    parser.add_argument('-d', '--directory', action="store", help='', default="./")
    parser.add_argument('-a', '--auto', action='store_const', const=True, help=_("automatic"), default=False)
    parser.add_argument('-s', '--show', action='store_const', const=True, help=_("show line"), default=False)
    parser.add_argument('-c', '--color', action='store_const', const=True, help=_("show color"), default=False)
    parser.add_argument('-bc', '--back-color', action='store_const', const=True, help=_("show backgroung color"), default=False)

    args = parser.parse_args()
    directory = args.directory
    file = args.file
    file_list = find(file ,directory)
    global old_word
    global new_word
    global _auto
    global _show
    global _color
    global _back_color
    global _no_change
    old_word = args.old_word
    new_word = args.new_word
    _auto = args.auto
    _show = args.show
    _color = args.color
    _back_color = args.back_color
    _no_change = False

    if (old_word == ""):
        old_word = input(_("old string = "))

    if (new_word == ""):
        new_word = input(_("new string = "))

    if (old_word == new_word):
        _no_change = True

    for file_name in file_list:
        if (_auto and _show):
            if _no_change:
                auto_and_show_no_change(file_name)
            else:
                auto_and_show(file_name)

        elif (_auto and not _show):
            auto_and_not_show(file_name)

        elif (not _auto and _show):
            if _no_change:
                not_auto_and_show_no_change(file_name)
            else:
                not_auto_and_show(file_name)

        else:
            not_auto_and_not_show(file_name)

    if (os.path.exists(_("new_empty.txt"))):
        os.remove(_("new_empty.txt"))
    print(_("number of replace word is: "),all_count)

if __name__ == "__main__":
    main()
